## performous 0.7.0

=== CMakeLists.txt ===
project(Performous CXX C)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)
set(PROJECT_VERSION "0.7.0")

# Avoid source tree pollution
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

# Packaging support (CPack) is disabled since Performous 0.7 release.
# If you are still using this, uncomment the following line (and update the file).
# Let us know if you still need it because otherwise we'll remove it entirely.
#include(cmake/performous-packaging.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake to set a proper value.")
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(WIN32)
	set(SHARE_INSTALL "." CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
else(WIN32)
	if(NOT SHARE_INSTALL)
		set(SHARE_INSTALL "share/games/performous" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
	endif(NOT SHARE_INSTALL)
endif(WIN32)

mark_as_advanced(SHARE_INSTALL)

#need to put here do setting LOCALE_DIR variable
find_package(Gettext)
if(Gettext_FOUND)
	if(NOT LOCALE_DIR)
		if(WIN32)
			SET(LOCALE_DIR "bin/locale")
		elseif(APPLE)
			SET(LOCALE_DIR "share/locale")
		else()#other os
			SET(LOCALE_DIR "share/locale")
		endif(WIN32)
	endif(NOT LOCALE_DIR)
	
	if(NOT LOCALE_DIR)
		message(QUIET "Set LOCALE_DIR to path to get Gettext working")
	else()
		find_package(Msgfmt)
		if(Msgfmt_FOUND)
			message(STATUS "Found msgfmt to convert language file. Translation enabled")
			add_subdirectory(lang)
		else()
			message(STATUS "Cannot find msgfmt to convert language file. Translation won't be enabled")
		endif()
	endif(NOT LOCALE_DIR)
endif(Gettext_FOUND)
add_subdirectory(themes)
add_subdirectory(data)
add_subdirectory(game)
add_subdirectory(docs)

option(ENABLE_TOOLS "Enable extra tools (e.g. Singstar ripper)" ON)

if (ENABLE_TOOLS)
  add_subdirectory(tools)
endif (ENABLE_TOOLS)

if(WIN32)
	option(ENABLE_VERSIONING "Add number version information. This allows to add version information to exe. Be carefull, in beta (and a lot useless)" OFF)
	install(FILES win32/ConfigureSongDirectory.bat DESTINATION bin)
endif(WIN32)

=== data/CMakeLists.txt ===
set(APPLICATION_FILE "performous.desktop")
set(PIXMAP_FILE      "performous.xpm")
set(CONFIG_FILE      "schema.xml")
set(CONTROLLERS_FILE "controllers.xml")
set(MIDIDRUMS_FILE   "mididrums.xml")

if(UNIX)
	install(FILES ${APPLICATION_FILE} DESTINATION "share/applications/")
	install(FILES ${PIXMAP_FILE} DESTINATION "share/pixmaps")
endif(UNIX)

install(FILES ${CONFIG_FILE} DESTINATION "${SHARE_INSTALL}/config/")
install(FILES ${CONTROLLERS_FILE} DESTINATION "${SHARE_INSTALL}/config/")
install(FILES ${MIDIDRUMS_FILE} DESTINATION "${SHARE_INSTALL}/config/")

file(GLOB XSL_FILES "*.xsl")
install(FILES ${XSL_FILES} DESTINATION "${SHARE_INSTALL}/xsl/")

file(GLOB SOUND_FILES "sounds/*.ogg")
install(FILES ${SOUND_FILES} DESTINATION "${SHARE_INSTALL}/sounds/")

file(GLOB BG_FILES "backgrounds/*.svg")
install(FILES ${BG_FILES} DESTINATION "${SHARE_INSTALL}/backgrounds/")

file(GLOB SHADER_FILES "shaders/*")
install(FILES ${SHADER_FILES} DESTINATION "${SHARE_INSTALL}/shaders/")

=== game/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

FILE(GLOB SOURCE_FILES "*.cc")
FILE(GLOB HEADER_FILES "*.hh")

if(WIN32)
  if(ENABLE_VERSIONING)
    set(COMMENTS)
	string(REGEX MATCHALL "([^\\.,^$]+)(\\.|,|$)"  VERSIONING ${PROJECT_VERSION})
	set(VERSIONS "MAJOR" "MINOR" "PATCH" "TWEAK")
	foreach(s ${VERSIONING})
		#we get the most-right number
		string(REGEX REPLACE "[^0-9]+$" "" s ${s})#removes most right part non-numeric (like .)
		#now we have a string in format <numbers-letters..........numbers>
		#take last numbers (if there are)
		#if string not empty, there are some numbers in right of string
		#otherwise, set a 0, to be sure that there's a number
		if(s STREQUAL "")
			set(s "0")
		endif()
		string(REGEX MATCH "[0-9]*$" s ${s})
		
		foreach(v ${VERSIONS})
			if(NOT VERSION_${v}_DONE)
				set(VERSION_${v}_DONE 1)
				set(VERSION_${v} "${s}")
				break()
			endif()
		endforeach()
	endforeach()

	foreach(v ${VERSIONS})
		if(NOT VERSION_${v}_DONE OR VERSION_${v} STREQUAL "") #For the substitution did before, in VERSION_${v} we have or a empty string (if all letters) or a number
			set(VERSION_${v} "0")
		endif()
	endforeach()
	message(STATUS "Setting .exe version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_TWEAK}")
  else(ENABLE_VERSIONING)
    set(COMMENTS "//")
  endif(ENABLE_VERSIONING)
  
  set(RESOURCE_FILES "${CMAKE_BINARY_DIR}/performous.rc")
  set(RESOURCE_OBJECT)#nothing
  
  configure_file("../win32/performous.cmake.rc" "${RESOURCE_FILES}")
  if(NOT MSVC)
    #in according to MinGW tools, we need to compile the rc file, and then link it into projects:
	#windres foo.rc foores.o
    #gcc -o foo.exe foo.o foores.o
	find_program(WINDRES windres)
	if(NOT WINDRES)
		message(STATUS "Cannot find windres. Will not create a versioned exe")
		set(RESOURCE_FILES)
		set(RESOURCE_OBJECT)
	else()
		set(RESOURCE_OBJECT "${CMAKE_BINARY_DIR}/performous.rc.o")
		execute_process(COMMAND "${WINDRES}" "${RESOURCE_FILES}" "${RESOURCE_OBJECT}")
	endif(NOT WINDRES)
  endif()
else()
  set(RESOURCE_FILES) #nothing
  set(RESOURCE_OBJECT)#nothing
endif()

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES} ${RESOURCE_FILES})

# Libraries

find_package(Boost 1.36 REQUIRED COMPONENTS thread date_time program_options regex filesystem system)
include_directories(${Boost_INCLUDE_DIRS})
list(APPEND LIBS ${Boost_LIBRARIES})

# Find all the libs that don't require extra parameters
foreach(lib ${OUR_LIBS} SDL PangoCairo LibRSVG LibXML++ GLEW AVFormat SWScale OpenGL Z Jpeg Png PortAudio)
	find_package(${lib} REQUIRED)
	include_directories(${${lib}_INCLUDE_DIRS})
	list(APPEND LIBS ${${lib}_LIBRARIES})
	add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

find_package(Gettext)
if(Gettext_FOUND)
	include_directories(${Gettext_INCLUDE_DIRS})
	list(APPEND LIBS ${Gettext_LIBRARIES})
	add_definitions("-DUSE_GETTEXT")
	message(STATUS "Internationalization: Enabled")
else()
	message(STATUS "Internationalization: Disabled (libintl not found)")
endif()

if(NOT NO_PORTMIDI)
	find_package(PortMidi)
	if(PortMidi_FOUND)
		include_directories(${PortMidi_INCLUDE_DIRS})
		list(APPEND LIBS ${PortMidi_LIBRARIES})
		add_definitions("-DUSE_PORTMIDI")
		message(STATUS "MIDI I/O: Enabled")
	else()
		message(STATUS "MIDI I/O: Disabled (libportmidi not found)")
	endif()
else()
	message(STATUS "MIDI I/O: Disabled (explicitly disabled)")
endif()

if(NOT NO_WEBCAM)
	find_package(OpenCV)
	if(OpenCV_FOUND)
		include_directories(${OpenCV_INCLUDE_DIRS})
		list(APPEND LIBS ${OpenCV_LIBS})
		add_definitions("-DUSE_OPENCV")
		message(STATUS "Webcam support: Enabled")
	else()
		message(STATUS "Webcam support: Disabled (libcv/libhighgui not found)")
	endif()
else()
	message(STATUS "Webcam support: Disabled (explicitly disabled)")
endif()


if(APPLE)
	# Needed for ffmpeg.cc to compile cleanly on OSX (it's a (unsigned long) long story)
	add_definitions("-D__STDC_CONSTANT_MACROS")
endif(APPLE)

if(UNIX)
	# Note: cannot use list APPEND here because it inserts semicolons instead of spaces
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
endif(UNIX)

if(MSVC)
	set(SUBSYSTEM_WIN32 WIN32)
	add_executable(performous-cmd "windows-cmd.cpp")
	install(TARGETS performous-cmd DESTINATION bin)
endif(MSVC)
add_executable(performous ${SUBSYSTEM_WIN32} ${SOURCES} ${SDL_SOURCES} ${RESOURCE_OBJECT})
target_link_libraries(performous ${LIBS})

# Store library paths in executable
if(APPLE)
	set_target_properties(performous PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
else()
	set_target_properties(performous PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

# Generate config.hh
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.hh" "${CMAKE_CURRENT_BINARY_DIR}/config.hh" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

install(TARGETS performous DESTINATION bin)

=== themes/CMakeLists.txt ===
FILE(GLOB THEME_FILES "default/*.ogg" "default/*.svg" "default/*.png" "default/*.bmp" "default/*.obj")
install(FILES ${THEME_FILES} DESTINATION ${SHARE_INSTALL}/themes/default/)

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# Libraries

find_package(Boost 1.34 REQUIRED COMPONENTS filesystem program_options)
include_directories(${Boost_INCLUDE_DIRS})

# Find all the libs that don't require extra parameters
foreach(lib LibXML++ Magick++ Z Jpeg Tiff Png Freetype Z)
	find_package(${lib})
	if (${lib}_FOUND)
		include_directories(${${lib}_INCLUDE_DIRS})
		add_definitions(${${lib}_DEFINITIONS})
	endif (${lib}_FOUND)
endforeach(lib)

# Set default compile flags for GCC
if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, enabling warnings")
	# Magick++ on OSX uses long long and thus cannot take -pedantic
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -Wall -Wextra")
endif(CMAKE_COMPILER_IS_GNUCXX)

if (LibXML++_FOUND)
	if (Boost_FOUND)
		if (Magick++_FOUND)
			if (Z_FOUND)
				add_executable(ss_extract ss_extract.cpp pak.cpp ipu_conv.cpp ss_cover.cpp)
				target_link_libraries(ss_extract ${LibXML++_LIBRARIES} ${Boost_LIBRARIES} ${Magick++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${Magick++_LIBRARIES})
				set(targets ${targets} ss_extract)
			else (Z_FOUND)
				message("No zlib found, not building ss_extract")
			endif (Z_FOUND)
		else (Magick++_FOUND)
			message("No Magick++ found, not building ss_extract")
		endif (Magick++_FOUND)
	else (Boost_FOUND)
		message("No Boost.Filesystem found, not building ss_extract")
	endif (Boost_FOUND)

	if (Magick++_FOUND)
		add_executable(ss_cover_conv cover_conv.cpp pak.cpp ss_cover.cpp)
		target_link_libraries(ss_cover_conv ${Magick++_LIBRARIES} ${LibXML++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${Magick++_LIBRARIES})
		set(targets ${targets} ss_cover_conv)
	else (Magick++_FOUND)
		message("No Magick++ found, not building ss_cover_conv")
	endif (Magick++_FOUND)
else (LibXML++_FOUND)
	message("No LibXML++ found, not building ss_extract nor ss_cover_conv")
endif (LibXML++_FOUND)

if (Boost_FOUND)
	add_executable(ss_pak_extract pak_extract.cpp pak.cpp)
	target_link_libraries(ss_pak_extract ${Boost_LIBRARIES})
	set(targets ${targets} ss_pak_extract)

	add_executable(ss_archive_extract archive_extract.cpp)
	target_link_libraries(ss_archive_extract ${Boost_LIBRARIES})
	set(targets ${targets} ss_archive_extract)

	if (Z_FOUND)
		add_executable(itg_pck itg_pck.cc)
		target_link_libraries(itg_pck ${Boost_LIBRARIES} ${Z_LIBRARIES})
		set(targets ${targets} itg_pck)

		add_executable(ss_chc_decode ss_chc_decode.cpp)
		target_link_libraries(ss_chc_decode ${Boost_LIBRARIES} ${Z_LIBRARIES})
		set(targets ${targets} ss_chc_decode)
	endif()
endif (Boost_FOUND)

add_subdirectory(gh_fsb)
add_executable(gh_xen_decrypt gh_xen_decrypt.cpp)
add_executable(ss_adpcm_decode adpcm_decode.cpp pak.cpp)
add_executable(ss_ipu_conv ipu_conv.cpp ipuconvmain.cpp pak.cpp)
set(targets ${targets} gh_xen_decrypt ss_adpcm_decode ss_ipu_conv)

# add install target:
install(TARGETS ${targets} DESTINATION bin)

=== docs/man/CMakeLists.txt ===
find_program(HELP2MAN help2man DOC "Location of the help2man program")
find_program(GZIP gzip DOC "Location of the gzip program")
mark_as_advanced(HELP2MAN)
mark_as_advanced(GZIP)
if(HELP2MAN AND GZIP)
	set(MANFILE ${CMAKE_CURRENT_BINARY_DIR}/performous.6.gz)
	set(H2MFILE ${CMAKE_CURRENT_SOURCE_DIR}/performous.h2m)
	set(PERFORMOUS_EXEC ${CMAKE_BINARY_DIR}/game/performous)
	add_custom_command(
		OUTPUT ${MANFILE}
		COMMAND ${HELP2MAN} ${PERFORMOUS_EXEC} -s 6 -i ${H2MFILE} -N | ${GZIP} > ${MANFILE}
		MAIN_DEPENDENCY ${H2MFILE}
		DEPENDS ${PERFORMOUS_EXEC}
		COMMENT "Building Performous man page"
		VERBATIM
	)
	add_custom_target(manpage ALL DEPENDS ${MANFILE})
	install(FILES ${MANFILE} DESTINATION share/man/man6)
else(HELP2MAN AND GZIP)
	message("WARNING: One of the following is missing: help2man, gzip; performous man page will not be generated")
endif(HELP2MAN AND GZIP)
if(ENABLE_TOOLS AND GZIP)
	set(TOOLS 
		"ss_pak_extract" "ss_extract" "ss_cover_conv"
		"ss_adpcm_decode" "ss_ipu_decode" "ss_ipu_conv"
		"gh_xen_decrypt" "ss_chc_decode")
	set(MAN_SECTION "1")
	foreach(TOOL ${TOOLS})
		set(TOOL_MANFILE ${CMAKE_CURRENT_SOURCE_DIR}/${TOOL}.${MAN_SECTION})
		set(TOOL_MANFILE_GZ ${CMAKE_CURRENT_BINARY_DIR}/${TOOL}.${MAN_SECTION}.gz)
		add_custom_command(
			OUTPUT ${TOOL_MANFILE_GZ}
			COMMAND ${GZIP} -c ${TOOL_MANFILE} > ${TOOL_MANFILE_GZ}
			MAIN_DEPENDENCY ${TOOL_MANFILE}
			COMMENT "Building ${TOOL} man page"
			VERBATIM
		)
		add_custom_target(${TOOL}.${MAN_SECTION} ALL DEPENDS ${TOOL_MANFILE_GZ})
		install(FILES ${TOOL_MANFILE_GZ} DESTINATION share/man/man${MAN_SECTION})
	endforeach(TOOL)
endif(ENABLE_TOOLS AND GZIP)

=== tools/gh_fsb/CMakeLists.txt ===
add_executable(gh_fsb_decrypt fsbext.c)

# add install target:
install(TARGETS gh_fsb_decrypt DESTINATION bin)

=== debian/changelog ===
performous (0.7.0-3) unstable; urgency=medium

  * Team upload.
  * Update the local FindFreeType.cmake file to detect the latest version of
    FreeType2 and make the software compile again. (Closes: #732735)
  * Bump Standards-Version to 3.9.5, no changes.

 -- Markus Koschany <apo@gambaru.de>  Wed, 22 Jan 2014 21:02:04 +0100

performous (0.7.0-2) unstable; urgency=low

  * Team upload.
  * debian/control:
    - Use canonical VCS-URI.
    - Remove versioned dependencies on boost libraries because they are
      trivially satisfied now.
    - Remove superfluous ${shlibs:Depends} substvar from performous-dbg
      package.
    - Bump Standards-Version to 3.9.4, no changes.
  * debian/copyright: Fix lintian issue copyright-refers-to-symlink-license and
    point to GPL-2 license.
  * Add use-Boost-TIME_UTC_-constant-unconditionally.patch. Use always the new
    Boost constant TIME_UTC_ and fix FTBFS with libboost1.49. (Closes: #710625)
  * Drop boost_filesystem_v2.patch. Not necessary for newer boost versions.

 -- Markus Koschany <apo@gambaru.de>  Sun, 30 Jun 2013 11:59:10 +0200

performous (0.7.0-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New upstream release.
  * Removed patches: jpeg-detection.patch and libav_api_change.patch
  * Upgraded debian/compat to 9.
  * Modified debian/rules to use fortified libc functions.
    See: http://wiki.debian.org/Hardening
  * Changed my email address in debian/control to miriam@debian.org

 -- Miriam Ruiz <miriam@debian.org>  Wed, 21 Nov 2012 00:01:41 +0100

performous (0.6.1-6) unstable; urgency=low

  * Team upload.

  [ Salvatore Bonaccorso ]
  * Add libpango1.0-dev to Build-Depends to fix FTBFS. (Closes: #665256)

  [ Ansgar Burchardt ]
  * Bump Standards-Version to 3.9.3 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Fri, 06 Apr 2012 10:04:51 +0200

=== debian/control ===
Source: performous
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Miriam Ruiz <miriam@debian.org>
Build-Depends: debhelper (>= 9),
 cmake (>= 2.6), pkg-config, help2man, gettext,
 libgl1-mesa-dev, libsdl1.2-dev, libcairo2-dev, librsvg2-dev,
 libboost-thread-dev, libboost-serialization-dev,
 libboost-program-options-dev, libboost-regex-dev,
 libboost-filesystem-dev,
 libavcodec-dev, libavformat-dev, libswscale-dev,
 libmagick++-dev, libsamplerate0-dev, libxml++2.6-dev,
 libasound2-dev, libjack-dev, libpulse-dev, portaudio19-dev,
 libgstreamer0.10-dev, libglew1.5-dev, libpango1.0-dev
Standards-Version: 3.9.5
Vcs-Svn: svn://anonscm.debian.org/pkg-games/packages/trunk/performous/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/performous/
Homepage: http://performous.org/

Package: performous
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Recommends: ${alsalibs:Recommends}
Conflicts: ultrastar-ng (<< 0.3.0)
Replaces: ultrastar-ng (<< 0.3.0)
Provides: ultrastar-ng
Description: karaoke game that allows user supplied songs
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.

Package: performous-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Recommends: vorbis-tools
Suggests: performous
Description: karaoke game that allows user supplied songs - tools
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
 .
 This package includes some tools for converting original Singstar DVDs to
 the format used by Performous.

Package: performous-dbg
Section: debug
Priority: extra
Architecture: any
Depends: performous (= ${binary:Version}) | performous-tools (= ${binary:Version}),
 ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Description: karaoke game that allows user supplied songs - debug
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
 .
 This package includes the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS2:=-Wl,-z,defs  -Wl,-as-needed -Wl,--no-undefined

# This has to be exported to make some magic below work.
export DH_OPTIONS

BUILD_TREE=$(CURDIR)/build-tree

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Perform an out-of-tree build to keep a clean source tree
	rm -rf $(BUILD_TREE)
	mkdir $(BUILD_TREE)
	cd $(BUILD_TREE); cmake .. \
		-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
		-DCMAKE_INSTALL_PREFIX:STRING="/usr" \
		-DLibDA_AUTODETECT_PLUGINS:BOOL=OFF \
		-DLibDA_PLUGIN_ALSA:BOOL=ON \
		-DLibDA_PLUGIN_GSTREAMER:BOOL=ON \
		-DLibDA_PLUGIN_JACK:BOOL=ON \
		-DLibDA_PLUGIN_PORTAUDIO:BOOL=ON \
		-DLibDA_PLUGIN_PULSE:BOOL=ON \
		-DLibDA_PLUGIN_TESTING:BOOL=OFF \
		-DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
		-DCMAKE_CXX_FLAGS:STRING="$(CXXFLAGS) $(CPPFLAGS)" \
		-DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
		-DCMAKE_EXE_LINKER_FLAGS:STRING="$(LDFLAGS) $(LDFLAGS2)" \
		-DCMAKE_MODULE_LINKER_FLAGS:STRING="$(LDFLAGS) $(LDFLAGS2)" \
		-DCMAKE_SHARED_LINKER_FLAGS:STRING="$(LDFLAGS) $(LDFLAGS2)"
	touch $@

build-stamp: configure-stamp 
	dh_testdir
	cd $(BUILD_TREE); $(MAKE)
	touch $@

build-indep: build-stamp

build-arch: build-stamp

build: build-arch build-indep

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	if [ -d $(BUILD_TREE) ]; then cd $(BUILD_TREE); $(MAKE) clean; fi
	rm -fr $(BUILD_TREE)
	$(MAKE) -C debian/h2m clean
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	cd $(BUILD_TREE); $(MAKE) install DESTDIR=$(CURDIR)/debian/performous
	$(MAKE) -C debian/h2m
	cp themes/default/icon.png $(CURDIR)/debian/performous/usr/share/pixmaps/performous.png
	mkdir -p  $(CURDIR)/debian/performous/usr/share/games/ultrastar/songs
	mv $(CURDIR)/debian/performous/usr/bin $(CURDIR)/debian/performous/usr/games

	# Remove development stuff
	rm -rf $(CURDIR)/debian/performous/usr/include
	rm -rf $(CURDIR)/debian/performous/usr/lib/*.a

	# Move tools to their own package
	mkdir -p $(CURDIR)/debian/performous-tools/usr/games
	cd $(CURDIR)/debian/performous/usr/games/ && \
		for i in ss_adpcm_decode ss_cover_conv ss_ipu_conv ss_ipu_decode \
			ss_archive_extract ss_chc_decode ss_pak_extract ss_extract \
			gh_fsb_decrypt gh_xen_decrypt itg_pck; do \
		mv $(CURDIR)/debian/performous/usr/games/"$$i" $(CURDIR)/debian/performous-tools/usr/games/ ; \
		done

# Build architecture independant packages using the common target.
binary-indep:
	dh_testdir
	dh_testroot
	dh_install -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_makeshlibs -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

# Build architecture dependant packages using the common target.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installmenu -a
	dh_installman -a
	dh_install -a
	dh_icons -a
	dh_link -a
	dh_strip --dbg-package=performous-dbg
	dh_compress -a 
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a \
		-Xusr/lib/performous/libda-1/
	dh_shlibdeps -a \
		-Xusr/lib/performous/libda-1/libda.a \
		-Xusr/lib/performous/libda-1/libda_audio_dev_gst.so \
		-Xusr/lib/performous/libda-1/libda_audio_dev_jack.so \
		-Xusr/lib/performous/libda-1/libda_audio_dev_pa19.so \
		-Xusr/lib/performous/libda-1/libda_audio_dev_pulse.so \
		-- -dRecommends -palsalibs
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-arch binary-indep
.PHONY: build-arch build-indep build clean binary-indep binary-arch binary install configure

=== debian/watch ===
# Watch control file for uscan
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Find new files on sourceforge, for debscripts >= 2.9
http://sf.net/performous/performous-(.*)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)

## performous 0.7.0+git20140715

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(Performous CXX C)
set(PROJECT_VERSION "0.8")
set(BUILD_SHARED_LIBS OFF)

# Avoid source tree pollution
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake to set a proper value.")
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE STREQUAL "Release")
	add_definitions("-DNDEBUG")
endif()

# Enable C++11 support and other compiler flags...
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
	message("Detected GCC version ${GCC_VERSION}")
	if (GCC_VERSION VERSION_GREATER 4.7 OR GCC_VERSION VERSION_EQUAL 4.7)
		set(CMAKE_CXX_FLAGS "-std=c++11 -Wall -Wextra -fcx-limited-range ${CMAKE_CXX_FLAGS}")
	elseif (GCC_VERSION VERSION_GREATER 4.6 OR GCC_VERSION VERSION_EQUAL 4.6)
		set(CMAKE_CXX_FLAGS "-std=c++0x -Wall -Wextra -fcx-limited-range ${CMAKE_CXX_FLAGS}")
		add_definitions("-Doverride=")  # Hack: GCC 4.6 doesn't understand C++11 "override" keyword
	else()
		message(FATAL_ERROR "Your GCC compiler does not support c++11, please install at least gcc 4.6")
	endif()
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
	set(CMAKE_CXX_FLAGS "-std=c++11 -Wall -Wextra ${CMAKE_CXX_FLAGS}")
endif()

if(WIN32)
	set(CMAKE_CXX_FLAGS "-DWIN32_LEAN_AND_MEAN ${CMAKE_CXX_FLAGS}")
	set(SHARE_INSTALL_DEFAULT ".")
	SET(LOCALE_DIR_DEFAULT "locale")
else()
	set(SHARE_INSTALL_DEFAULT "share/games/performous")
	SET(LOCALE_DIR_DEFAULT "share/locale")
endif()

set(SHARE_INSTALL "${SHARE_INSTALL_DEFAULT}" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
mark_as_advanced(SHARE_INSTALL)

set(LOCALE_DIR "${LOCALE_DIR_DEFAULT}" CACHE STRING "Locale file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
mark_as_advanced(LOCALE_DIR)

find_package(Gettext)
find_package(Msgfmt)
if(Gettext_FOUND AND Msgfmt_FOUND)
	message(STATUS "Localization enabled: Building and installing .mo files")
	add_subdirectory(lang)
else()
	message(STATUS "Localization disabled: Gettext or Msgfmt missing")
endif()

add_subdirectory(data)
add_subdirectory(game)

option(ENABLE_TOOLS "Enable building of song extraction utilities for SingStar and Guitar Hero." ON)
if(ENABLE_TOOLS)
	add_subdirectory(tools)
endif()

add_subdirectory(docs)

if(WIN32)
	option(ENABLE_VERSIONING "Add version number information. This allows adding version information to the EXE. Be careful, in beta." OFF)
	install(FILES win32/ConfigureSongDirectory.bat DESTINATION .)
endif()

=== game/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

file(GLOB SOURCE_FILES "*.cc")
file(GLOB HEADER_FILES "*.hh" "libda/*.hpp")

if(WIN32)
	if(ENABLE_VERSIONING)
		set(COMMENTS)
		string(REGEX MATCHALL "([^\\.,^$]+)(\\.|,|$)"  VERSIONING ${PROJECT_VERSION})
		set(VERSIONS "MAJOR" "MINOR" "PATCH" "TWEAK")
		foreach(s ${VERSIONING})
			# We get the most-right number
			string(REGEX REPLACE "[^0-9]+$" "" s ${s})#removes most right part non-numeric (like .)
			# Now we have a string in format <numbers-letters..........numbers>
			# Take last numbers (if there are)
			# If string not empty, there are some numbers in right of string
			# otherwise, set a 0, to be sure that there's a number
			if(s STREQUAL "")
				set(s "0")
			endif()
			string(REGEX MATCH "[0-9]*$" s ${s})

			foreach(v ${VERSIONS})
				if(NOT VERSION_${v}_DONE)
					set(VERSION_${v}_DONE 1)
					set(VERSION_${v} "${s}")
					break()
				endif()
			endforeach()
		endforeach()

		foreach(v ${VERSIONS})
			if(NOT VERSION_${v}_DONE OR VERSION_${v} STREQUAL "") #For the substitution did before, in VERSION_${v} we have or a empty string (if all letters) or a number
				set(VERSION_${v} "0")
			endif()
		endforeach()
		message(STATUS "Setting .exe version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_TWEAK}")
	else(ENABLE_VERSIONING)
		set(COMMENTS "//")
	endif(ENABLE_VERSIONING)
	set(RESOURCE_FILES "${CMAKE_BINARY_DIR}/performous.rc")

	configure_file("../win32/performous.cmake.rc" "${RESOURCE_FILES}")
	if(MINGW)
		# According to MinGW tools, we need to compile the rc file, and then link it into projects:
		# windres foo.rc foores.o
		# gcc -o foo.exe foo.o foores.o
		if(NOT CMAKE_RC_COMPILER)
			find_program(CMAKE_RC_COMPILER windres)
		endif()
		if(NOT CMAKE_RC_COMPILER)
			message(STATUS "Cannot find windres. Will not create a versioned exe.")
			set(RESOURCE_FILES)
		else()
			set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
		endif()
	endif()
else()
	set(RESOURCE_FILES) #nothing
endif()

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES} ${RESOURCE_FILES})

# Libraries

find_package(Boost 1.36 REQUIRED COMPONENTS thread date_time program_options regex filesystem system)
include_directories(${Boost_INCLUDE_DIRS})
list(APPEND LIBS ${Boost_LIBRARIES})

# Find all the libs that don't require extra parameters
foreach(lib ${OUR_LIBS} SDL2 PangoCairo LibRSVG LibXML++ GLEW AVFormat AVResample SWScale OpenGL Z Jpeg Png PortAudio Fontconfig)
	find_package(${lib} REQUIRED)
	message(STATUS "${lib} includes: ${${lib}_INCLUDE_DIRS}")
	include_directories(${${lib}_INCLUDE_DIRS})
	list(APPEND LIBS ${${lib}_LIBRARIES})
	add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

find_package(Gettext)
if(Gettext_FOUND)
	include_directories(${Gettext_INCLUDE_DIRS})
	list(APPEND LIBS ${Gettext_LIBRARIES})
	add_definitions("-DUSE_GETTEXT")
	message(STATUS "Internationalization: Enabled")
else()
	message(STATUS "Internationalization: Disabled (libintl not found)")
endif()

option(ENABLE_MIDI "Enable support for MIDI hardware (e-drums with USB/MIDI connection)." ON)
if(ENABLE_MIDI)
	find_package(PortMidi)
	if(PortMidi_FOUND)
		include_directories(${PortMidi_INCLUDE_DIRS})
		list(APPEND LIBS ${PortMidi_LIBRARIES})
		add_definitions("-DUSE_PORTMIDI")
		message(STATUS "MIDI I/O: Enabled")
	else()
		message(STATUS "MIDI I/O: Disabled (libportmidi not found)")
	endif()
else()
	message(STATUS "MIDI I/O: Disabled (explicitly disabled)")
endif()

option(ENABLE_WEBCAM "Enable webcam support (OpenCV)." ON)
if(ENABLE_WEBCAM)
	find_package(OpenCV)
	if(OpenCV_FOUND)
		include_directories(${OpenCV_INCLUDE_DIRS})
		list(APPEND LIBS ${OpenCV_LIBS})
		add_definitions("-DUSE_OPENCV")
		message(STATUS "Webcam support: Enabled")
	else()
		message(STATUS "Webcam support: Disabled (libcv/libhighgui not found)")
	endif()
else()
	message(STATUS "Webcam support: Disabled (explicitly disabled)")
endif()


if(APPLE)
	# Needed for ffmpeg.cc to compile cleanly on OSX (it's a (unsigned long) long story)
	add_definitions("-D__STDC_CONSTANT_MACROS")
endif(APPLE)

if(UNIX)
	# Note: cannot use list APPEND here because it inserts semicolons instead of spaces
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
endif(UNIX)

if(WIN32)
	option(MXE_HACK "Features horrible hacks, but is able to compile a static performous.exe (that may not work)." OFF)
	mark_as_advanced(MXE_HACK)
	if(MXE_HACK)
		execute_process(COMMAND "${CMAKE_SOURCE_DIR}/win32/mxe/libs.sh"
			OUTPUT_VARIABLE MXE_HACK_STRING
		)
		set(CMAKE_CXX_LINK_EXECUTABLE ${CMAKE_CXX_LINK_EXECUTABLE}${MXE_HACK_STRING})
		add_definitions(-DBOOST_THREAD_USE_LIB -DGLEW_STATIC)
	endif()
	set(BIN_INSTALL .)  # Straight to Program Files/Performous with no bin subfolder.
	set(SUBSYSTEM_WIN32 WIN32)
else()
	set(BIN_INSTALL bin)
endif()

# Build main executable
add_executable(performous ${SUBSYSTEM_WIN32} ${SOURCES} ${SDL2_SOURCES})
target_link_libraries(performous ${LIBS})
install(TARGETS performous DESTINATION ${BIN_INSTALL})

set_target_properties(performous PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)  # Store library paths in executable
set_target_properties(performous PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})  # Produce executable in build/, not build/game/

# Capitalized Performous.exe on Windows (this is considered more beautiful).
if(WIN32)
	set_target_properties(performous PROPERTIES OUTPUT_NAME "Performous")
endif()

# Generate config.hh
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.hh" "${CMAKE_CURRENT_BINARY_DIR}/config.hh" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# Libraries

find_package(Boost 1.34 REQUIRED COMPONENTS filesystem program_options system)
include_directories(${Boost_INCLUDE_DIRS})

# Find all the libs that don't require extra parameters

if (APPLE)
    foreach(lib LibXML++ Z Jpeg Tiff Png Freetype Z)
	find_package(${lib})
    	if (${lib}_FOUND)
	    	include_directories(${${lib}_INCLUDE_DIRS})
		    add_definitions(${${lib}_DEFINITIONS})
    	endif (${lib}_FOUND)
    endforeach(lib)

    # CMake cannot properly detect Magick++ on Mac the other way.

    find_package(ImageMagick COMPONENTS Magick++)
    include_directories(${ImageMagick_INCLUDE_DIRS})
else (APPLE)
    foreach(lib LibXML++ Z Magick++ Jpeg Tiff Png Freetype Z)
	    find_package(${lib})
    	if (${lib}_FOUND)
	    	include_directories(${${lib}_INCLUDE_DIRS})
		    add_definitions(${${lib}_DEFINITIONS})
    	endif (${lib}_FOUND)
    endforeach(lib)
endif (APPLE)

# Set default compile flags for GCC
if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, enabling warnings")
	# Magick++ on OSX uses long long and thus cannot take -pedantic
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -Wall -Wextra")
endif(CMAKE_COMPILER_IS_GNUCXX)

if (LibXML++_FOUND)
	if (Boost_FOUND)
		if (ImageMagick_FOUND OR Magick++_FOUND) 
			if (Z_FOUND)
				add_executable(ss_extract ss_extract.cc pak.cc ipu_conv.cc ss_cover.cc)
				target_link_libraries(ss_extract ${LibXML++_LIBRARIES} ${Boost_LIBRARIES} ${Magick++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${ImageMagick_LIBRARIES})
				set(targets ${targets} ss_extract)
			else (Z_FOUND)
				message("No zlib found, not building ss_extract")
			endif (Z_FOUND)
		else (ImageMagick_FOUND OR Magick++_FOUND)
			message("No Magick++ found, not building ss_extract")
		endif (ImageMagick_FOUND OR Magick++_FOUND)
	else (Boost_FOUND)
		message("No Boost.Filesystem found, not building ss_extract")
	endif (Boost_FOUND)

	if (ImageMagick_FOUND OR Magick++_FOUND)
		add_executable(ss_cover_conv cover_conv.cc pak.cc ss_cover.cc)
		target_link_libraries(ss_cover_conv ${ImageMagick_LIBRARIES} ${LibXML++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${ImageMagick_LIBRARIES} ${Magick++_LIBRARIES})
		set(targets ${targets} ss_cover_conv)
	else (ImageMagick_FOUND OR Magick++_FOUND)
		message("No Magick++ found, not building ss_cover_conv")
	endif (ImageMagick_FOUND OR Magick++_FOUND)
else (LibXML++_FOUND)
	message("No LibXML++ found, not building ss_extract nor ss_cover_conv")
endif (LibXML++_FOUND)

if (Boost_FOUND AND Z_FOUND)
	add_executable(ss_archive_extract archive_extract.cc)
	target_link_libraries(ss_archive_extract ${Boost_LIBRARIES} ${Z_LIBRARIES})
	set(targets ${targets} ss_archive_extract)

	add_executable(ss_pak_extract pak_extract.cc pak.cc)
	target_link_libraries(ss_pak_extract ${Boost_LIBRARIES} ${Z_LIBRARIES})
	set(targets ${targets} ss_pak_extract)

	add_executable(itg_pck itg_pck.cc)
	target_link_libraries(itg_pck ${Boost_LIBRARIES} ${Z_LIBRARIES})
	set(targets ${targets} itg_pck)

	add_executable(ss_chc_decode ss_chc_decode.cc)
	target_link_libraries(ss_chc_decode ${Boost_LIBRARIES} ${Z_LIBRARIES})
	set(targets ${targets} ss_chc_decode)

endif()

if (Z_FOUND)
	add_executable(ss_adpcm_decode adpcm_decode.cc pak.cc)
	target_link_libraries(ss_adpcm_decode ${Z_LIBRARIES})
	set(targets ${targets} ss_adpcm_decode)
endif()

add_executable(gh_fsb_decrypt gh_fsb/fsbext.c)
add_executable(gh_xen_decrypt gh_xen_decrypt.cc)
add_executable(ss_ipu_conv ipu_conv.cc ipuconvmain.cc pak.cc)
set(targets ${targets} gh_fsb_decrypt gh_xen_decrypt ss_adpcm_decode ss_ipu_conv)

# add install target:
if(WIN32)
	install(TARGETS ${targets} DESTINATION tools)
else()
	install(TARGETS ${targets} DESTINATION bin)
endif()

=== debian/changelog ===
performous (0.7.0+git20140715-2) unstable; urgency=medium

  * Add fix-imagemagick-detection.patch. (Closes: #767755)
    Detect ImageMagick library and build the ss_extract and ss_cover_conv
    binaries again which were accidentally dropped.
  * Add use-avconv.patch. (Closes: #699400)
    Replace ffmpeg command with avconv for ss_extract tool because ffmpeg
    will not be available for Jessie.
  * performous-tools: Depend on libav-tools because ss_extract requires
    the avconv command.
  * Move the package to Git. Change Vcs fields accordingly.

 -- Markus Koschany <apo@gambaru.de>  Sun, 02 Nov 2014 13:46:41 +0100

performous (0.7.0+git20140715-1) unstable; urgency=medium

  * Imported Upstream version 0.7.0+git20140715.
    - Fixes FTBFS with libav10. (Closes: #739433, #754486)
  * Add libavresample-dev to Build-Depends. Needed for libav10.
  * Update README.source for new release.
  * Drop desktop-file.patch. Merged upstream.
  * Switch to SDL2 by using libsdl2-dev instead of libsdl1.2-dev.

 -- Markus Koschany <apo@gambaru.de>  Tue, 15 Jul 2014 16:42:04 +0200

performous (0.7.0+git20140217-1) unstable; urgency=medium

  * Imported Upstream version 0.7.0+git20140217.
    - Update to recommended git master version. (Closes: #710332)
    - Fix audio noise when entering the game. (Closes: #740763)
  * Add myself to Uploaders.
  * Enable MIDI I/O support.
  * debian/rules:
    - Switch to dh sequencer and simplify debian/rules.
    - Build with --parallel.
    - Remove all overrides in regard to libda.
    - Use only required dh_auto_configure options.
    - Export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed.
    - Do not create separate ultrastar directory anymore.
  * wrap-and-sort -sa
  * debian/control:
    - Remove unnecessary build-dependencies:
      + libsamplerate0-dev
      + libpulse-dev
      + libgstreamer0.10-dev
      + libjack-dev
    - Use libboost-all-dev instead of single boost libraries.
    - Switch to libglew-dev from libglew1.5-dev.
    - Add libportmidi-dev [linux-any] and enable MIDI I/O support.
    - Add libpng-dev and libjpeg-dev.
    - Remove Conflicts, Replaces, Provides fields for obsolete ultrastar
      package.
    - Remove Pre-Depends dpkg (>= 1.15.6)
    - performous: Add fonts-droid dependency.
    - performous: Remove Recommends: ${alsalibs:Recommends} substvar.
  * source/options: Use default xz compression.
  * Update desktop.patch to desktop-file.patch and create a valid desktop file.
  * Drop use-Boost-TIME_UTC_-constant-unconditionally.patch. Fixed upstream.
  * Drop FindFreetype.patch. Fixed upstream.
  * Drop libav0.8.patch. Fixed upstream.
  * Update README.source. Explain how one can obtain the original sources.
  * debian/docs: Do not install TODO.txt anymore. It does no longer exist.
  * Drop debian/h2m folder. It is obsolete.
  * Add longtitle to performous.menu.
  * Add performous-tools.install file.
  * Update README.Debian. Mention ~/.local/share/games/performous/songs as an
    alternative song location. (Closes: #718897)
  * Drop ultrastar-ng.links.
  * Update debian/copyright to copyright format 1.0. Add Sil Open Fonts
    license.
  * Install performous.svg to /usr/share/icons/hicolor/scalable/apps.

 -- Markus Koschany <apo@gambaru.de>  Sat, 08 Mar 2014 11:52:55 +0100

=== debian/control ===
Source: performous
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Miriam Ruiz <miriam@debian.org>,
 Markus Koschany <apo@gambaru.de>
Build-Depends:
 cmake,
 debhelper (>= 9),
 gettext,
 help2man,
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavresample-dev,
 libboost-all-dev,
 libcairo2-dev,
 libgl1-mesa-dev,
 libglew-dev,
 libjpeg-dev,
 libmagick++-dev,
 libpango1.0-dev,
 libpng-dev,
 libportmidi-dev [linux-any],
 librsvg2-dev,
 libsdl2-dev,
 libswscale-dev,
 libxml++2.6-dev,
 pkg-config,
 portaudio19-dev
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-games/performous.git
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/performous.git
Homepage: http://performous.org/

Package: performous
Architecture: any
Depends:
 fonts-droid,
 ${misc:Depends},
 ${shlibs:Depends}
Description: karaoke game that allows user supplied songs
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.

Package: performous-tools
Architecture: any
Depends:
 libav-tools,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 vorbis-tools
Suggests:
 performous
Description: karaoke game that allows user supplied songs - tools
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
 .
 This package includes some tools for converting original Singstar DVDs to
 the format used by Performous.

Package: performous-dbg
Section: debug
Priority: extra
Architecture: any
Depends:
 performous (= ${binary:Version}) | performous-tools (= ${binary:Version}),
 ${misc:Depends}
Description: karaoke game that allows user supplied songs - debug
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
 .
 This package includes the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_INSTALL_PREFIX=/usr

override_dh_install:
	dh_install --fail-missing
	$(RM) debian/performous-tools/usr/games/performous

override_dh_strip:
	dh_strip --dbg-package=performous-dbg

=== debian/watch ===
version=3
http://sf.net/performous/performous-(.*)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)

## performous 1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.8)
 project(Performous CXX C)
-set(PROJECT_VERSION "0.8")
+set(PROJECT_VERSION "1.0")
 set(BUILD_SHARED_LIBS OFF)
 
 # Avoid source tree pollution

=== debian/changelog ===
performous (1.0-2) experimental; urgency=medium

  * Merge unstable changes from 0.7.0+git20140715-2 into experimental branch.
  * debian/rules: Build without Altivec on ppc64el to prevent build failures.
  * Remove source/options since performous uses CMake anyway.
  * Add fix-spelling-errors.patch:
    Fix spelling errors informations and Unkown. Thanks to Lintian.

 -- Markus Koschany <apo@gambaru.de>  Wed, 05 Nov 2014 11:55:48 +0100

performous (1.0-1) experimental; urgency=medium

  * Imported Upstream version 1.0.
  * Move the package to Git.
  * Update debian/watch and detect new releases at github.com.
  * Declare compliance with Debian Policy 3.9.6.
  * Drop README.source. The upstream sources are pristine.
  * Update debian/copyright. Add Apache-2.0 license paragraph.
  * Add fix-hyphen-used-as-minus-sign.patch to silence Lintian and forward the
    patch upstream.

 -- Markus Koschany <apo@gambaru.de>  Sat, 01 Nov 2014 17:04:05 +0100

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
  libxml++2.6-dev,
  pkg-config,
  portaudio19-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/pkg-games/performous.git
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-games/performous.git
 Homepage: http://performous.org/
